#!/usr/bin/env python3
# -*- coding: utf-8 -*-

#   Copyright (C) 2012  P.L. Lucas
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import sys
import os
import re

class ProcessItem:
	def __init__(self):
		self.pid=-1
		self.cmdline=None

def pstree_read_file(path):
	try:
		fin=open(path,'r')
		content=fin.read()
		fin.close()
		return content
	except:
		return None

def pstree_get_last_child(ppid):
	last_child=None
	check_re=re.compile('[0-9]+')
	for item in os.listdir('/proc'):
		if None!=check_re.match(item) and int(item)>ppid: # List process pid in proc filesystem
			pid=int(item)
			# Check if child of ppid
			stat = pstree_read_file('/proc/'+item+'/stat')
			if stat!=None:
				item_ppid=stat.split()[3]
				if int(item_ppid)==ppid:
					# Find last child of process
					child=pstree_get_last_child(pid)
					if child==None:
						child=ProcessItem()
						child.pid=pid
						child.cmdline= pstree_read_file('/proc/'+item+'/cmdline')
					if (last_child!=None and last_child.pid<child.pid) or last_child==None:
						last_child=child
	return last_child

#print(pstree_get_last_child(8468).pid)
